unit untIsValidPe;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, XPMan, pngimage, ExtCtrls;

function IsValidPe(FileName :String) :Boolean;

implementation

{
    Coder: Xash
    Website: hacksecu.com
    Compiled: Delphi 2007
}

function IsValidPe(FileName :String) :Boolean;
// by Xash
var
  hFile       :DWORD;
  DosHeader   :TImageDosHeader;
  NtHeaders   :TImageNtHeaders;
  dwRead      :DWORD;
begin
  Result := True;

  if not FileExists(FileName) then // Si le fichier n'existe pas on ne continue pas
  begin
    Result := False;
    Exit;
  end;

  hFile := CreateFile(PChar(FileName), GENERIC_READ, FILE_SHARE_READ, nil, OPEN_EXISTING, 0, 0); // On ouvre le fichier en mode lecture
  try
    try
      SetFilePointer(hFile, 0, nil, FILE_BEGIN);
      ReadFile(hFile, DosHeader, SizeOf(DosHeader), dwRead, nil); // On lit l'entte DOS

      if DosHeader.e_magic <> IMAGE_DOS_SIGNATURE then // Si la signature n'est pas valide (MZ)
        Result := False
      else
      begin
        SetFilePointer(hFile, DosHeader._lfanew, nil, FILE_BEGIN); // On place le curseur au dbut de l'entte PE
        ReadFile(hFile, NtHeaders, SizeOf(NtHeaders), dwRead, nil); // On lit l'entte PE

        if NtHeaders.Signature <> IMAGE_NT_SIGNATURE then // Si la signature n'est pas valide (PE\0\0)
          Result := False;
      end;
    except
      On Exception do
        Result := False; // Si il y a un problme on retourne false
    end;
  finally
    CloseHandle(hFile);
  end;
end;

end.
 